#!/usr/bin/env python
# -*- coding: utf-8 -*-

# Created by Tin Tran
# Comments directed to https://gimplearn.net
#
# License: GPLv3
# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY# without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
# GNU General Public License for more details.
#
# To view a copy of the GNU General Public License
# visit: http://www.gnu.org/licenses/gpl.html

# ------------
#| Change Log |
# ------------
# Rel 1: Initial release
# Rel 2: Set active layer as well so that gmic filter can work on active layer.
# Rel 3: Added layer type selections (proposal by MareroQ)

from gimpfu import *
import math
#from inspect import formatargspec, getfullargspec

def python_run_code_on_selected_layers(image, layer, laymode, code) : #FUNCTION DEFINITION
	pdb.gimp_image_undo_group_start(image)
	pdb.gimp_context_push()
	#YOUR CODE BEGINS=======================
	apply_layers = []
	if laymode==0:
		for layer in image.layers:
			apply_layers.append(layer)	
	if laymode==1:
		for layer in image.layers:
			if layer.visible:
				apply_layers.append(layer)
	if laymode==2:
		for layer in image.layers:
			if not layer.visible:
				apply_layers.append(layer)
	if laymode==3:
		for layer in image.layers:
			if layer.linked:
				apply_layers.append(layer)
	if laymode==4:
		for layer in image.layers:
			if not layer.linked:
				apply_layers.append(layer)				
	
	#apply code to apply_layers now
	for layer in apply_layers:
		pdb.gimp_image_set_active_layer(image,layer)
		exec(code)
	#YOUR CODE ENDS ========================
	pdb.gimp_context_pop()
	pdb.gimp_image_undo_group_end(image)
	pdb.gimp_displays_flush()
    #return

register(
	"python_fu_run_code_on_selected_layers",
	"Run code on selected layers",
	"Run code on selected layers...",
	"Tin Tran",
	"Tin Tran",
	"Oct 2017",
	"<Image>/Python-Fu/Run Code on Selected Layers...",
	"*",      # Create a new image, don't work on an existing one
	[ 
	#INPUT BEGINS
	(PF_OPTION, "laymode", "Choose on what layers:", 1, ["ALL LAYER", "VISIBLE LAYER", "NOT-VISIBLE LAYER", "LINKED LAYER", "NOT-LINKED LAYER"]),	
	(PF_STRING, "code", "Code to Run:", "pdb.gimp_image_select_item(image,CHANNEL_OP_REPLACE,layer);pdb.gimp_edit_fill(layer,PATTERN_FILL)"),
	],
	[],
	python_run_code_on_selected_layers)

main()
